searchData={"items":[{"type":"module","title":"Genies.Config","doc":"","ref":"Genies.Config.html"},{"type":"function","title":"Genies.Config.resolve/2","doc":"","ref":"Genies.Config.html#resolve/2"},{"type":"module","title":"Genies.Openai","doc":"","ref":"Genies.Openai.html"},{"type":"function","title":"Genies.Openai.assistants/1","doc":"","ref":"Genies.Openai.html#assistants/1"},{"type":"module","title":"Genies.Openai.Api","doc":"","ref":"Genies.Openai.Api.html"},{"type":"function","title":"Genies.Openai.Api.prepare/1","doc":"","ref":"Genies.Openai.Api.html#prepare/1"},{"type":"function","title":"Genies.Openai.Api.put_header/3","doc":"","ref":"Genies.Openai.Api.html#put_header/3"},{"type":"module","title":"Genies.Openai.Assistant","doc":"The Assistant context","ref":"Genies.Openai.Assistant.html"},{"type":"function","title":"Genies.Openai.Assistant.create/1","doc":"Creates a new assistant.\n\nSee: https://platform.openai.com/docs/api-reference/assistants/createAssistant","ref":"Genies.Openai.Assistant.html#create/1"},{"type":"function","title":"Example request - Genies.Openai.Assistant.create/1","doc":"iex> create(%Assistant{})\n  {:ok, %Assistant{}}","ref":"Genies.Openai.Assistant.html#create/1-example-request"},{"type":"function","title":"Genies.Openai.Assistant.delete/1","doc":"Gets a single assistant.\n\nSee: https://platform.openai.com/docs/api-reference/assistants/deleteAssistant","ref":"Genies.Openai.Assistant.html#delete/1"},{"type":"function","title":"Examples - Genies.Openai.Assistant.delete/1","doc":"iex> delete(\"asst_\")\n    {:ok, \n      %{\n        \"id\": \"asst_abc123\",\n        \"object\": \"assistant.deleted\",\n        \"deleted\": true\n      }\n    }","ref":"Genies.Openai.Assistant.html#delete/1-examples"},{"type":"function","title":"Genies.Openai.Assistant.modify/2","doc":"Modifies a single assistant.\n\nSee: https://platform.openai.com/docs/api-reference/assistants/modifyAssistant","ref":"Genies.Openai.Assistant.html#modify/2"},{"type":"function","title":"Examples - Genies.Openai.Assistant.modify/2","doc":"iex> modify(\"asst_\", attrs)\n    {:ok, %Assistant{}}","ref":"Genies.Openai.Assistant.html#modify/2-examples"},{"type":"function","title":"Genies.Openai.Assistant.new/1","doc":"","ref":"Genies.Openai.Assistant.html#new/1"},{"type":"function","title":"Genies.Openai.Assistant.new!/1","doc":"","ref":"Genies.Openai.Assistant.html#new!/1"},{"type":"function","title":"Genies.Openai.Assistant.retrieve/1","doc":"Retrieves a single assistant.\n\nSee: https://platform.openai.com/docs/api-reference/assistants/getAssistant","ref":"Genies.Openai.Assistant.html#retrieve/1"},{"type":"function","title":"Examples - Genies.Openai.Assistant.retrieve/1","doc":"iex> retrieve(\"asst_\")\n    {:ok, %Assistant{}}","ref":"Genies.Openai.Assistant.html#retrieve/1-examples"},{"type":"module","title":"Genies.Openai.Chain","doc":"The Chain context","ref":"Genies.Openai.Chain.html"},{"type":"function","title":"Genies.Openai.Chain.add_functions/2","doc":"","ref":"Genies.Openai.Chain.html#add_functions/2"},{"type":"function","title":"Genies.Openai.Chain.add_message/2","doc":"","ref":"Genies.Openai.Chain.html#add_message/2"},{"type":"function","title":"Genies.Openai.Chain.common_validation/1","doc":"","ref":"Genies.Openai.Chain.html#common_validation/1"},{"type":"function","title":"Genies.Openai.Chain.new/1","doc":"","ref":"Genies.Openai.Chain.html#new/1"},{"type":"function","title":"Genies.Openai.Chain.new!/1","doc":"","ref":"Genies.Openai.Chain.html#new!/1"},{"type":"function","title":"Genies.Openai.Chain.run/1","doc":"Runs a chain","ref":"Genies.Openai.Chain.html#run/1"},{"type":"function","title":"Example - Genies.Openai.Chain.run/1","doc":"iex> %{assistant_id: assistant.asst_id, thread_id: thread_id}\n        |> Chain.new!()\n        |> Chain.run()","ref":"Genies.Openai.Chain.html#run/1-example"},{"type":"module","title":"Genies.Openai.Function","doc":"","ref":"Genies.Openai.Function.html"},{"type":"function","title":"Genies.Openai.Function.execute/3","doc":"","ref":"Genies.Openai.Function.html#execute/3"},{"type":"function","title":"Genies.Openai.Function.new/1","doc":"","ref":"Genies.Openai.Function.html#new/1"},{"type":"function","title":"Genies.Openai.Function.new!/1","doc":"","ref":"Genies.Openai.Function.html#new!/1"},{"type":"module","title":"Genies.Openai.Message","doc":"","ref":"Genies.Openai.Message.html"},{"type":"function","title":"Genies.Openai.Message.new/1","doc":"","ref":"Genies.Openai.Message.html#new/1"},{"type":"function","title":"Genies.Openai.Message.new!/1","doc":"","ref":"Genies.Openai.Message.html#new!/1"},{"type":"function","title":"Genies.Openai.Message.new_assistant/2","doc":"","ref":"Genies.Openai.Message.html#new_assistant/2"},{"type":"function","title":"Genies.Openai.Message.new_assistant!/2","doc":"","ref":"Genies.Openai.Message.html#new_assistant!/2"},{"type":"function","title":"Genies.Openai.Message.new_system/2","doc":"","ref":"Genies.Openai.Message.html#new_system/2"},{"type":"function","title":"Genies.Openai.Message.new_system!/2","doc":"","ref":"Genies.Openai.Message.html#new_system!/2"},{"type":"function","title":"Genies.Openai.Message.new_user/2","doc":"","ref":"Genies.Openai.Message.html#new_user/2"},{"type":"function","title":"Genies.Openai.Message.new_user!/2","doc":"","ref":"Genies.Openai.Message.html#new_user!/2"},{"type":"module","title":"Genies.Openai.Schema.MessageContent","doc":"","ref":"Genies.Openai.Schema.MessageContent.html"},{"type":"function","title":"Genies.Openai.Schema.MessageContent.changeset/2","doc":"","ref":"Genies.Openai.Schema.MessageContent.html#changeset/2"},{"type":"module","title":"Genies.Openai.Schema.MessageContent.Image","doc":"","ref":"Genies.Openai.Schema.MessageContent.Image.html"},{"type":"function","title":"Genies.Openai.Schema.MessageContent.Image.changeset/2","doc":"","ref":"Genies.Openai.Schema.MessageContent.Image.html#changeset/2"},{"type":"module","title":"Genies.Openai.Schema.MessageContent.Text","doc":"","ref":"Genies.Openai.Schema.MessageContent.Text.html"},{"type":"function","title":"Genies.Openai.Schema.MessageContent.Text.changeset/2","doc":"","ref":"Genies.Openai.Schema.MessageContent.Text.html#changeset/2"},{"type":"module","title":"Genies.Openai.Schema.RunError","doc":"","ref":"Genies.Openai.Schema.RunError.html"},{"type":"function","title":"Genies.Openai.Schema.RunError.changeset/2","doc":"","ref":"Genies.Openai.Schema.RunError.html#changeset/2"},{"type":"module","title":"Genies.Openai.Schema.RunRequiredAction","doc":"","ref":"Genies.Openai.Schema.RunRequiredAction.html"},{"type":"function","title":"Genies.Openai.Schema.RunRequiredAction.changeset/2","doc":"","ref":"Genies.Openai.Schema.RunRequiredAction.html#changeset/2"},{"type":"module","title":"Genies.Openai.Schema.Tool","doc":"","ref":"Genies.Openai.Schema.Tool.html"},{"type":"function","title":"Genies.Openai.Schema.Tool.changeset/2","doc":"","ref":"Genies.Openai.Schema.Tool.html#changeset/2"},{"type":"function","title":"Genies.Openai.Schema.Tool.function_changeset/2","doc":"","ref":"Genies.Openai.Schema.Tool.html#function_changeset/2"},{"type":"module","title":"Genies.Openai.Schema.Tool.Function","doc":"","ref":"Genies.Openai.Schema.Tool.Function.html"},{"type":"module","title":"Genies.Openai.Thread","doc":"The Thread context","ref":"Genies.Openai.Thread.html"},{"type":"function","title":"Genies.Openai.Thread.create/1","doc":"Creates a new thread.\n\nSee: https://platform.openai.com/docs/api-reference/threads/createThread","ref":"Genies.Openai.Thread.html#create/1"},{"type":"function","title":"Example request - Genies.Openai.Thread.create/1","doc":"iex> create(%{})\n  {:ok, %Thread{}}","ref":"Genies.Openai.Thread.html#create/1-example-request"},{"type":"function","title":"Genies.Openai.Thread.delete/1","doc":"Retrieves a single thread.\n\nSee: https://platform.openai.com/docs/api-reference/threads/deleteThread","ref":"Genies.Openai.Thread.html#delete/1"},{"type":"function","title":"Example request - Genies.Openai.Thread.delete/1","doc":"iex> delete(\"thread_\")\n  {:ok, \n    %{\n      \"id\": \"asst_abc123\",\n      \"object\": \"assistant.deleted\",\n      \"deleted\": true\n    }\n  }","ref":"Genies.Openai.Thread.html#delete/1-example-request"},{"type":"function","title":"Genies.Openai.Thread.new/1","doc":"","ref":"Genies.Openai.Thread.html#new/1"},{"type":"function","title":"Genies.Openai.Thread.new!/1","doc":"","ref":"Genies.Openai.Thread.html#new!/1"},{"type":"function","title":"Genies.Openai.Thread.retrieve/1","doc":"Retrieves a single thread.\n\nSee: https://platform.openai.com/docs/api-reference/threads/getThread","ref":"Genies.Openai.Thread.html#retrieve/1"},{"type":"function","title":"Example request - Genies.Openai.Thread.retrieve/1","doc":"iex> retrieve(\"thread_\")\n  {:ok, %Thread{}}","ref":"Genies.Openai.Thread.html#retrieve/1-example-request"},{"type":"module","title":"Genies.Openai.Thread.Message","doc":"","ref":"Genies.Openai.Thread.Message.html"},{"type":"function","title":"Genies.Openai.Thread.Message.create/2","doc":"","ref":"Genies.Openai.Thread.Message.html#create/2"},{"type":"function","title":"Genies.Openai.Thread.Message.list/1","doc":"","ref":"Genies.Openai.Thread.Message.html#list/1"},{"type":"function","title":"Genies.Openai.Thread.Message.modify/3","doc":"","ref":"Genies.Openai.Thread.Message.html#modify/3"},{"type":"function","title":"Genies.Openai.Thread.Message.new/1","doc":"","ref":"Genies.Openai.Thread.Message.html#new/1"},{"type":"function","title":"Genies.Openai.Thread.Message.new!/1","doc":"","ref":"Genies.Openai.Thread.Message.html#new!/1"},{"type":"function","title":"Genies.Openai.Thread.Message.retrieve/2","doc":"","ref":"Genies.Openai.Thread.Message.html#retrieve/2"},{"type":"module","title":"Genies.Openai.Thread.Run","doc":"","ref":"Genies.Openai.Thread.Run.html"},{"type":"function","title":"Genies.Openai.Thread.Run.cancel/2","doc":"","ref":"Genies.Openai.Thread.Run.html#cancel/2"},{"type":"function","title":"Genies.Openai.Thread.Run.create/2","doc":"","ref":"Genies.Openai.Thread.Run.html#create/2"},{"type":"function","title":"Genies.Openai.Thread.Run.list/1","doc":"","ref":"Genies.Openai.Thread.Run.html#list/1"},{"type":"function","title":"Genies.Openai.Thread.Run.new/1","doc":"","ref":"Genies.Openai.Thread.Run.html#new/1"},{"type":"function","title":"Genies.Openai.Thread.Run.new!/1","doc":"","ref":"Genies.Openai.Thread.Run.html#new!/1"},{"type":"function","title":"Genies.Openai.Thread.Run.retrieve/2","doc":"","ref":"Genies.Openai.Thread.Run.html#retrieve/2"},{"type":"function","title":"Genies.Openai.Thread.Run.submit_tool_out_put/3","doc":"tool_outputs is a list\n  https://platform.openai.com/docs/api-reference/runs/submitToolOutputs?lang=curl","ref":"Genies.Openai.Thread.Run.html#submit_tool_out_put/3"},{"type":"module","title":"Genies.Utils","doc":"","ref":"Genies.Utils.html"},{"type":"function","title":"Genies.Utils.changeset_error_to_string/1","doc":"Return changeset errors as text with comma separated description.","ref":"Genies.Utils.html#changeset_error_to_string/1"},{"type":"function","title":"Genies.Utils.translate_errors/2","doc":"Translates the errors for a field from a keyword list of errors.","ref":"Genies.Utils.html#translate_errors/2"},{"type":"exception","title":"Genies.Error","doc":"","ref":"Genies.Error.html"},{"type":"function","title":"Genies.Error.exception/1","doc":"Create the exception using either a message or a changeset who's errors are\nconverted to a message.","ref":"Genies.Error.html#exception/1"},{"type":"type","title":"Genies.Error.t/0","doc":"","ref":"Genies.Error.html#t:t/0"},{"type":"extras","title":"Genie","doc":"# Genie\n\n**TODO: Add description**","ref":"readme.html"},{"type":"extras","title":"Installation - Genie","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `genies` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:genie, \"~> 0.0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Genie","doc":"You can configure openai in your mix config.exs (default $project_root/config/config.exs). If you're using Phoenix add the configuration in your config/dev.exs|test.exs|prod.exs files. An example config is:\n\n```elixir\nimport Config\n\nconfig :genies, :openai, \n    # find it at https://platform.openai.com/account/api-keys\n    api_key: System.get_env(\"OPENAI_API_KEY\"),\n    # find it at https://platform.openai.com/account/org-settings under \"Organization ID\"\n    api_org: System.get_env(\"OPENAI_ORG\")\n```\nNote: you can load your os ENV variables in the configuration file, if you set an env variable for API key named `OPENAI_API_KEY` you can get it in the code by doing `System.get_env(\"OPENAI_API_KEY\")`.\n\n⚠️`config.exs` is compile time, so the `get_env/1` function is executed during the build, if you want to get the env variables during runtime please use `runtime.exs` instead of `config.exs` in your application ([elixir doc ref](https://elixir-lang.org/getting-started/mix-otp/config-and-releases.html#configuration)).\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#configuration"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}